﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Windows.Data;

namespace SL_DTP_InGrid_MinAndMaxValue1
{
    public class DatePickerSelector : GridViewBoundColumnBase
    {
        private DateTime? _originalValue;

        public override FrameworkElement CreateCellEditElement(GridViewCell cell, object dataItem)
        {
            var dteNow = DateTime.Today.AddDays(DateTime.Today.Day - 1);
            var dteStart = dteNow.AddMonths(-24);
            var dteEnd = dteNow.AddYears(30);

            RadDatePicker cellEditElement = new RadDatePicker()
            {
                DateSelectionMode = Telerik.Windows.Controls.Calendar.DateSelectionMode.Month,
                DisplayDateStart = dteStart,
                DisplayDateEnd = dteEnd,
                SelectableDateStart = dteStart,
                SelectableDateEnd = dteEnd
            };
            cellEditElement.ParseDateTimeValue += (s, args) =>
            {
                var datePicker = s as RadDatePicker;

                if (args.IsParsingSuccessful)
                {
                    if (args.Result < datePicker.SelectableDateStart)
                    {
                        args.Result = datePicker.SelectableDateStart;
                    }
                    if (args.Result > datePicker.SelectableDateEnd)
                    {
                        args.Result = datePicker.SelectableDateEnd;
                    }
                }

            };

            this.BindingTarget = RadDatePicker.SelectedDateProperty;

            cellEditElement.Culture = new System.Globalization.CultureInfo("en-GB");
            cellEditElement.Culture.DateTimeFormat.ShortDatePattern = "MM/yyyy";
            cellEditElement.DisplayFormat = DateTimePickerFormat.Short;

            Binding valueBinding = this.CreateValueBinding();
            cellEditElement.SetBinding(RadDatePicker.SelectedDateProperty, valueBinding);

            _originalValue = cellEditElement.SelectedDate;

            return cellEditElement as FrameworkElement;
        }

        public override FrameworkElement CreateCellElement(GridViewCell cell, object dataItem)
        {
            TextBlock cellElement = new TextBlock();
            var valueBinding = new System.Windows.Data.Binding("StartDate")
            {
                Mode = BindingMode.TwoWay,
                StringFormat = "{0:MM/yyyy}"
            };
            cellElement.SetBinding(TextBlock.TextProperty, valueBinding);
            return cellElement;
        }

        private Binding CreateValueBinding()
        {
            Binding b = new Binding("StartDate");
            b.Mode = BindingMode.TwoWay;
            return b;
        }

    }
}
